* Shows how you can update the look of your reports and add some new functionalities to them.

* To change the appearance of ALL your reports automatically

* For that we are going to use a system variable new to Visual FoxPro 9.0, _REPORTPREVIEW. 
* This variable identifies a program. VFP uses _REPORTPREVIEW to identify the preview container factory application.
* This program is called by Visual FoxPro when:

*  the report engine is assisted by a ReportListener object, and 
*  the ReportListener has a ListenerType of 1, and 
*  the ReportListener does not already have an object reference assigned to its .PreviewContainer property. 

* You would not believe how much easier this is than it sounds:

LOCAL lcFile
lcFile = FULLPATH("FoxyPreviewer.App")
_ReportPreview = lcFile
SET REPORTBEHAVIOR 90
REPORT FORM (ADDBS(HOME(1)) + "Samples\Solution\Reports\colors.frx") PREVIEW

* If you need to change the _ReportPreview factory again in the same VFP session, you can:
* CLEAR ALL
*
* or, a much more elegant solution, by Colin Nicholls:
* http://spacefold.com/colin/archive/articles/reportpreview/rp_extend.html
* _oReportOutput["1"].PreviewContainer = .NULL.