* FoxyPreviewer Version 1.18

LPARAMETER loPreviewContainer

#DEFINE PR_ENGLISH
* #DEFINE PR_PORTUGUES
* #DEFINE PR_ESPANIOL
* #DEFINE PR_GERMAN
* #DEFINE PR_TURKISH 
* #DEFINE PR_ITALIANO

#IFDEF  PR_ENGLISH
	#DEFINE PR_MENUTOP        'First page'
	#DEFINE PR_MENUPREV       'Previous'
	#DEFINE PR_MENUNEXT       'Next'
	#DEFINE PR_MENULAST       'Last Page'
	#DEFINE PR_MENUGOTO       'Go to page'
	#DEFINE PR_MENUSHOWPAGES  'Show pages'
	#DEFINE PR_MENUPRINT      'Print report'
	#DEFINE PR_MENUCLOSE      'Close preview'
	#DEFINE PR_MENUTOOLB      "Toolbar"

	#DEFINE PR_CBOZOOMWHOLEPG "Whole Page"
	#DEFINE PR_CBOZOOMPGWIDTH "Page Width"
	#DEFINE PR_CMDGOTOPGTTIP  "Go to page"

	#DEFINE PR_ONEPGTTIP      "One page"
	#DEFINE PR_TWOPGTTIP      "Two pages"
	#DEFINE PR_FOURPGTTIP     "Four pages"

	#DEFINE PR_REPORTTITLE    "Previewing Report..."
	#DEFINE PR_ERR_CREATINGFILE "Failed creating file !" + CHR(13) + "Please try again later."
	#DEFINE PR_ERROR          "Error"

	#DEFINE PR_MENUPROOF      "\<Miniatures..."

	#DEFINE PR_COPIES         "Copies"
	#DEFINE PR_SAVEREPORT     "Save Report"

	#DEFINE PR_SAVEASIMAGE    "Save as image file..."
	#DEFINE PR_SAVEASPDF      "Save as PDF"
	#DEFINE PR_SAVEASHTML     "Save as HTML"
	#DEFINE PR_SAVEASRTF      "Save as RTF"

	#DEFINE PR_SENDTOEMAIL    "Send report by e-mail"
	#DEFINE PR_CLOSEREPORT    "Close Report"
	#DEFINE PR_PRINTREPORT    "Print Report"
	#DEFINE PR_MINIATURES     "Show Miniatures"
	#DEFINE PR_GLOBALPREVIEW  "Global Preview"

	#DEFINE PR_AVAILABLEPRINT "Available Printers"

	#DEFINE PR_GOTOPG_CAPTION PR_MENUGOTO
	#DEFINE PR_GOTOPG_OK      "Ok"
	#DEFINE PR_GOTOPG_CANCEL  "Cancel"

	#DEFINE PR_PRINTINGPREF   "Printing Preferences"
#ENDIF


#IFDEF  PR_PORTUGUES

	#DEFINE PR_NONENGLISH

	#DEFINE PR_MENUTOP        'Incio'
	#DEFINE PR_MENUPREV       'Pg. Anterior'
	#DEFINE PR_MENUNEXT       'Pg. Seguinte'
	#DEFINE PR_MENULAST       'ltima pgina'
	#DEFINE PR_MENUGOTO       'Ir para pgina'
	#DEFINE PR_MENUSHOWPAGES  'Mostrar pginas'
	#DEFINE PR_MENUPRINT      'Imprimir'
	#DEFINE PR_MENUCLOSE      'Fechar'
	#DEFINE PR_MENUTOOLB      "Barra de Ferramentas"

	#DEFINE PR_CBOZOOMWHOLEPG "Pgina Inteira"
	#DEFINE PR_CBOZOOMPGWIDTH "Largura da Pgina"
	#DEFINE PR_CMDGOTOPGTTIP  "Ir para a pgina"

	#DEFINE PR_ONEPGTTIP      "Uma pgina"
	#DEFINE PR_TWOPGTTIP      "Duas pginas"
	#DEFINE PR_FOURPGTTIP     "Quatro pginas"

	#DEFINE PR_ONEPGMENU	  "1 pgina"
	#DEFINE PR_TWOPGMENU	  "2 pginas"
	#DEFINE PR_FOURPGMENU	  "4 pginas"

	#DEFINE PR_REPORTTITLE    "Previsualizando relatrio..."
	#DEFINE PR_ERR_CREATINGFILE "Falha na criao do arquivo !" + CHR(13) + "Tente novamente."
	#DEFINE PR_ERROR          "Erro"

	#DEFINE PR_MENUPROOF      "\<Miniaturas..."

	#DEFINE PR_COPIES         "Cpias"
	#DEFINE PR_SAVEREPORT     "Salvar relatrio"

	#DEFINE PR_SAVEASIMAGE    "Salvar em arquivo de imagem..."
	#DEFINE PR_SAVEASPDF      "Salvar em PDF"
	#DEFINE PR_SAVEASHTML     "Salvar em HTML"
	#DEFINE PR_SAVEASRTF      "Salvar em RTF"

	#DEFINE PR_SENDTOEMAIL    "Enviar relatrio por email"
	#DEFINE PR_CLOSEREPORT    "Fechar relatrio"
	#DEFINE PR_PRINTREPORT    "Imprimir"
	#DEFINE PR_MINIATURES     "Mostrar Miniaturas"
	#DEFINE PR_GLOBALPREVIEW  "Previsualizao geral"

	#DEFINE PR_AVAILABLEPRINT "Impressoras disponveis"

	#DEFINE PR_GOTOPG_CAPTION PR_MENUGOTO
	#DEFINE PR_GOTOPG_OK      "Ok"
	#DEFINE PR_GOTOPG_CANCEL  "Cancelar"

	#DEFINE PR_PRINTINGPREF   "Preferncias de Impresso"

#ENDIF


* Spanish translation
#IFDEF	PR_ESPANIOL

	#DEFINE PR_NONENGLISH

	#DEFINE PR_MENUTOP			'Inicio'
	#DEFINE PR_MENUPREV			'Pgina anterior'
	#DEFINE PR_MENUNEXT 		'Pgina siguiente'
	#DEFINE PR_MENULAST 		'ltima pgina'
	#DEFINE PR_MENUGOTO 		'Ir a pgina'
	#DEFINE PR_MENUSHOWPAGES 	'Mostrar pginas'
	#DEFINE PR_MENUPRINT 		'Imprimir'
	#DEFINE PR_MENUCLOSE 		'Cerrar'

	#DEFINE PR_MENUTOOLB 		"Barra de herramientas"

	#DEFINE PR_CBOZOOMWHOLEPG 	"Pgina entera"
	#DEFINE PR_CBOZOOMPGWIDTH 	"Ancho de pgina"
	#DEFINE PR_CMDGOTOPGTTIP 	"Ir a pgina"

	#DEFINE PR_ONEPGTTIP 		"Una pgina"
	#DEFINE PR_TWOPGTTIP 		"Dos pginas"
	#DEFINE PR_FOURPGTTIP 		"Cuatro pginas"
	
	#DEFINE PR_ONEPGMENU		"1 pgina"
	#DEFINE PR_TWOPGMENU		"2 pginas"
	#DEFINE PR_FOURPGMENU		"4 pginas"
	
	#DEFINE PR_REPORTTITLE 		"Vista previa del informe..."
	#DEFINE PR_ERR_CREATINGFILE "No se pudo crear el archivo!" + CHR(13) + "Por favor intntelo nuevamente."
	#DEFINE PR_ERROR 			"Error"
	#DEFINE PR_MENUPROOF 		"\<Miniaturas..."
	#DEFINE PR_COPIES 			"Copias"
	#DEFINE PR_SAVEREPORT 		"Guardar informe"

	#DEFINE PR_SAVEASIMAGE 		"Guardar como archivo de imagen ..."
	#DEFINE PR_SAVEASPDF 		"Guardar como PDF"
	#DEFINE PR_SAVEASHTML 		"Guardar como HTML"
	#DEFINE PR_SAVEASRTF 		"Guardar como RTF"

	#DEFINE PR_SENDTOEMAIL 		"Enviar informe por correo electrnico"
	#DEFINE PR_CLOSEREPORT 		"Cerrar informe"
	#DEFINE PR_PRINTREPORT 		"Imprimir informe"
	#DEFINE PR_MINIATURES 		"Mostrar miniaturas"
	#DEFINE PR_GLOBALPREVIEW 	"Vista previa global"
	#DEFINE PR_AVAILABLEPRINT 	"Impresoras disponibles"

	#DEFINE PR_GOTOPG_CAPTION PR_MENUGOTO
	#DEFINE PR_GOTOPG_OK		"Ok"
	#DEFINE PR_GOTOPG_CANCEL	"Cancelar"

	#DEFINE PR_PRINTINGPREF   "Preferencias de impresin"

#ENDIF

* German translation
#IFDEF PR_GERMAN
	#DEFINE PR_NONENGLISH

	#DEFINE PR_MENUTOP 'Erste Seite'
	#DEFINE PR_MENUPREV 'Zurck'
	#DEFINE PR_MENUNEXT 'Vor'
	#DEFINE PR_MENULAST 'Letzte Seite'
	#DEFINE PR_MENUGOTO 'Gehe zu Seite'
	#DEFINE PR_MENUSHOWPAGES 'Anzahl Seiten'
	#DEFINE PR_MENUPRINT 'Drucken'
	#DEFINE PR_MENUCLOSE 'Ende'
	#DEFINE PR_MENUTOOLB "Toolbar"

	#DEFINE PR_CBOZOOMWHOLEPG "Ganze Seite"
	#DEFINE PR_CBOZOOMPGWIDTH "Seitenbreite"
	#DEFINE PR_CMDGOTOPGTTIP "Gehe zu Seite"

	#DEFINE PR_ONEPGTTIP "1 Seite"
	#DEFINE PR_TWOPGTTIP "2 Seiten"
	#DEFINE PR_FOURPGTTIP "4 Seiten"

	#DEFINE PR_REPORTTITLE "Vorschau fr ..."
	#DEFINE PR_ERR_CREATINGFILE "Dateifehler" + CHR(13) + "Bitte versuchen Sie es noch einmal"
	#DEFINE PR_ERROR "Fehler"

	#DEFINE PR_ONEPGMENU	"1 Seite"
	#DEFINE PR_TWOPGMENU	"2 Seiten"
	#DEFINE PR_FOURPGMENU	"4 Seiten"

	#DEFINE PR_MENUPROOF "\<Miniaturbilder.."

	#DEFINE PR_COPIES "Kopien"
	#DEFINE PR_SAVEREPORT "Speichern"

	#DEFINE PR_SAVEASIMAGE "Speichern als Bild"
	#DEFINE PR_SAVEASPDF "Speichern als PDF "
	#DEFINE PR_SAVEASHTML "Speichern als HTML"
	#DEFINE PR_SAVEASRTF "Speichern als RTF "

	#DEFINE PR_SENDTOEMAIL "Als Email versenden"
	#DEFINE PR_CLOSEREPORT "Ende"
	#DEFINE PR_PRINTREPORT "Drucken"
	#DEFINE PR_MINIATURES "Zeige Miniaturbilder"
	#DEFINE PR_GLOBALPREVIEW "bersicht"

	#DEFINE PR_AVAILABLEPRINT "Vorhandene Drucker"

	#DEFINE PR_GOTOPG_CAPTION PR_MENUGOTO
	#DEFINE PR_GOTOPG_OK      "Ok"
	#DEFINE PR_GOTOPG_CANCEL  "Abbrechen"

	#DEFINE PR_PRINTINGPREF   "Druckoptionen"
#ENDIF


* Turkish translation
#IFDEF  PR_TURKISH 

	#DEFINE PR_NONENGLISH

	#DEFINE PR_MENUTOP        'Ilk Sayfa' 
	#DEFINE PR_MENUPREV       'nceki Sayfa' 
	#DEFINE PR_MENUNEXT       'Sonraki Sayfa' 
	#DEFINE PR_MENULAST       'Son Sayfa' 
	#DEFINE PR_MENUGOTO       'Sayfaya Git' 
	#DEFINE PR_MENUSHOWPAGES  'Sayfalari Gster' 
	#DEFINE PR_MENUPRINT      'Raporu Yazdir' 
	#DEFINE PR_MENUCLOSE      'nizlemeyi Kapat' 
	#DEFINE PR_MENUTOOLB      "Ara ubugu" 

	#DEFINE PR_CBOZOOMWHOLEPG "Tm Sayfa" 
	#DEFINE PR_CBOZOOMPGWIDTH "Sayfa Genisligi" 
	#DEFINE PR_CMDGOTOPGTTIP  "Sayfaya Git" 

	#DEFINE PR_ONEPGTTIP      "Tek Sayfa" 
	#DEFINE PR_TWOPGTTIP      "Iki Sayfa" 
	#DEFINE PR_FOURPGTTIP     "Drt Sayfa" 

	#DEFINE PR_ONEPGMENU	PR_ONEPGTTIP
	#DEFINE PR_TWOPGMENU	PR_TWOPGTTIP
	#DEFINE PR_FOURPGMENU	PR_FOURPGTTIP

	#DEFINE PR_REPORTTITLE    "Rapor nizleme..." 	
	#DEFINE PR_ERR_CREATINGFILE "Dosya Olusturma Hatasi !" + CHR(13) + "Tekrar Deneyin.." 
	#DEFINE PR_ERROR          "Hata" 

	#DEFINE PR_MENUPROOF      "\<Minyatrler..." 

	#DEFINE PR_COPIES         "Kopya Sayisi" 
	#DEFINE PR_SAVEREPORT     "Raporu Kaydet" 

	#DEFINE PR_SAVEASIMAGE    "Image Dosyasi Olarak Kaydet..." 	
	#DEFINE PR_SAVEASPDF      "PDF Olarak Kaydet" 
	#DEFINE PR_SAVEASHTML     "HTML Olarak Kaydet" 
	#DEFINE PR_SAVEASRTF      "RTF Olarak Kaydet" 

	#DEFINE PR_SENDTOEMAIL    "Raporu e-mail olarak gnder" 
	#DEFINE PR_CLOSEREPORT    "Kapat" 
	#DEFINE PR_PRINTREPORT    "Yazdir" 
	#DEFINE PR_MINIATURES     "Minyatrleri Gster" 
	#DEFINE PR_GLOBALPREVIEW  "Genel nizleme" 

	#DEFINE PR_AVAILABLEPRINT "Kullanilabilir Yazicilar" 

	#DEFINE PR_GOTOPG_CAPTION PR_MENUGOTO 
	#DEFINE PR_GOTOPG_OK      "Tamam" 
	#DEFINE PR_GOTOPG_CANCEL  "Vazge" 

	#DEFINE PR_PRINTINGPREF   "Yazim tercihleri"

#ENDIF


* Italian translation
#IFDEF  PR_ITALIANO 

	#DEFINE PR_NONENGLISH

	#DEFINE PR_MENUTOP        'Prima pagina' 
	#DEFINE PR_MENUPREV       'Precedente' 
	#DEFINE PR_MENUNEXT       'Successiva' 
	#DEFINE PR_MENULAST       'Iltima pagina' 
	#DEFINE PR_MENUGOTO       'Vai alla pagina' 
	#DEFINE PR_MENUSHOWPAGES  'Visualizza pagine' 
	#DEFINE PR_MENUPRINT      'Stampa' 
	#DEFINE PR_MENUCLOSE      'Chiudi anteprima' 
	#DEFINE PR_MENUTOOLB      "Toolbar" 

	#DEFINE PR_CBOZOOMWHOLEPG "Tulla la pagina" 
	#DEFINE PR_CBOZOOMPGWIDTH "Larghezza pagina" 
	#DEFINE PR_CMDGOTOPGTTIP  "Vai a pagina" 

	#DEFINE PR_ONEPGTTIP      "Una pagina" 
	#DEFINE PR_TWOPGTTIP      "Due pagine" 
	#DEFINE PR_FOURPGTTIP     "Quattro pagine" 

	#DEFINE PR_ONEPGMENU	PR_ONEPGTTIP
	#DEFINE PR_TWOPGMENU	PR_TWOPGTTIP
	#DEFINE PR_FOURPGMENU	PR_FOURPGTTIP

	#DEFINE PR_REPORTTITLE    "Anteprima stampa..." 
	#DEFINE PR_ERR_CREATINGFILE "Errore nella creazione del file !" + CHR(13) + "Riprovare pi tardi." 
	#DEFINE PR_ERROR          "Errore" 

	#DEFINE PR_MENUPROOF      "\<Miniature..."
	#DEFINE PR_COPIES         "Copie" 
	#DEFINE PR_SAVEREPORT     "Salva Stampa" 

	#DEFINE PR_SAVEASIMAGE    "Salva come immagine..." 
	#DEFINE PR_SAVEASPDF      "Salva come PDF" 
	#DEFINE PR_SAVEASHTML     "Salva come HTML" 
	#DEFINE PR_SAVEASRTF      "Salva come RTF" 

	#DEFINE PR_SENDTOEMAIL    "Invia la stampa per e-mail" 
	#DEFINE PR_CLOSEREPORT    "Chiudi stampa" 
	#DEFINE PR_PRINTREPORT    "stampa" 
	#DEFINE PR_MINIATURES     "Visualizza miniature" 
	#DEFINE PR_GLOBALPREVIEW  "Anteprima globale" 

	#DEFINE PR_AVAILABLEPRINT "Stampanti disponibili" 

	#DEFINE PR_GOTOPG_CAPTION PR_MENUGOTO 
	#DEFINE PR_GOTOPG_OK      "Ok" 
	#DEFINE PR_GOTOPG_CANCEL  "Annullare" 

	#DEFINE PR_PRINTINGPREF   "Preferenze stampa"

#ENDIF 


LOCAL loPreviewContainer AS FORM, ;
	loListener AS REPORTLISTENER, ;
	loExHandler AS ExtensionHandler OF SYS(16)

*-- Get a preview container from the
*-- .APP registered to handle object-assisted
*-- report previewing.
loPreviewContainer = NULL
DO HOME() + "ReportPreview.App" WITH loPreviewContainer

* Create a PREVIEW listener
TRY 
	loListener = NEWOBJECT('FXListener', "Listener.vcx", "ReportOutput.App")
CATCH
	loListener = CREATEOBJECT("ReportListener")
ENDTRY 
loListener.LISTENERTYPE = 1 && Preview

*-- Link the Listener and preview container
loListener.PREVIEWCONTAINER = loPreviewContainer

* Create an extension handler and hook it to the
* preview container. This will let you manipulate
* properties of the container and its Preview toolbar
loExHandler = NEWOBJECT('ExtensionHandler')

RELEASE goHelper
PUBLIC  goHelper
goHelper = CREATEOBJECT("PreviewHelper")
goHelper.lExtended = .F.
_oExHandler = loExHandler

loPreviewContainer.SetExtensionHandler(loExHandler)

RELEASE loPreviewContainer, loReportListener, loExHandler
RETURN


DEFINE CLASS PreviewHelper AS Custom
	cPrinterName = SET("Printer",3)

	lSaveToFile     = .T. && adds the save to file button
	lSendToEmail    = .F. && adds the send to email button
	lPrintVisible   = .T. && shows the print button in the toolbar
	lShowCopies     = .T. && shows the copies spinner
	lShowMiniatures = .T. && shows the miniatures page
	lPrinterPref    = .T. && shows the printer preferences button

	cDestFile       = ""  && the destination file (image, htm, pdf, etc)

	lPrinted        = .F.  && knows if the user printed the report
	lSaved          = .F.  && knows if the user saved the report to a file
	nPageTotal      = 0 && Total pages of the current report
	nCopies         = 1 && The quantity of copies to be printed
	cTitle          = PR_REPORTTITLE && The preview window title 
	oListener = NULL
	cDefaultListener = "FXLISTENER"
	nCanvasCount = 1 && initial nr of pages rendered on the preview form. 
			&& Valid values are 1 (default), 2, or 4.

	nZoomLevel = 5 && initial zoom level of the preview window. Possible values are:
			&& 1-10%, 2-25%, 3-50%, 4-75%, 5-100% default, 6-150% ;
			&& 7-200%, 8-300%, 9-500%, 10-whole page

	lExtended = .T. && Flag that tells if the report is being run automatically
					&& using the _REPORTPERVIEW global variable


	* Internal use properties
	_ClausenRangeFrom = 1
	_ClausenRangeTo = -1 && All pages
	_ClauselSummary = .F.
	_ClausecHeading = ""

	_cFRXName      = "" && the ReportFrxName
	_cFRXFullName  = ""

	_oReports = "" && Internal use, collection that contains the report names to be used
	_oClauses = ""
	_oProofSheet = ""

	_cOriginalPrinter = SET("Printer",3)
	_lSendToPrinter = .F.	&& Flag that will tell the object to 
							&& run the report again and send the output 
							&& to another printer after the preview window is closed
	_lNoWait = .F.
	_OldReportOutput = ""
	_oExHandler = ""

PROCEDURE Init

	IF This.lExtended = .T.
		RELEASE goHelper
		PUBLIC goHelper
		goHelper = This

		LOCAL lcClassPath, lcPDFFile, lcTestPath
		lcClassPath = IIF(EMPTY(This.ClassLibrary), "", ADDBS(JUSTPATH(This.ClassLibrary)))
		lcPDFFile = "libhpdf.dll"
		IF FILE(lcPDFFile) AND EMPTY(SYS(2000,lcPDFFile))
			** File is an embedded resource

			lcTestPath = lcClassPath + lcPDFFile && FULLPATH("libhpdf.dll")
			DECLARE INTEGER PathFileExists IN shlwapi STRING pszPath
			IF PathFileExists(lcTestPath + CHR(0)) = 0
				STRTOFILE(FILETOSTR(lcPDFFile), lcClassPath + lcPDFFile)
	    	ENDIF
		ENDIF 
	ENDIF 
ENDPROC 

PROCEDURE Destroy
	* Just for safety, to ensure the helper object will not remain in memory
	RELEASE goHelper
ENDPROC 

PROCEDURE CloseProof
	IF VARTYPE(This._oProofSheet) = "O"
		This._oProofSheet.Release()
	ENDIF 
ENDPROC 


PROCEDURE AddReport(tcReport, tcClauses)
* populates a collection object with the report files and clauses
* This method can be called many times, providing an easy way to merge reports.
	IF VARTYPE(This._oReports) <> "O"
		This._oReports = CREATEOBJECT("Collection")
		This._oClauses = CREATEOBJECT("Collection")
	ENDIF
	This._oReports.Add(tcReport)
	This._oClauses.Add(EVL(tcClauses,""))
ENDPROC


PROCEDURE CallReport(toListener as ReportListener, tlKeepHandle)
	* Executar o relatrio
	LOCAL lcReport, lcClauses, loListener as ReportListener 

	IF VARTYPE(toListener) = "O"
		loListener = toListener
	ELSE
		loListener = This.oListener
	ENDIF 

*	IF UPPER(This._cOriginalPrinter) <> UPPER(This.cPrinterName)
	IF UPPER(ALLTRIM(SET("Printer", 3))) <> UPPER(This.cPrinterName)
		This.SetPrinter(This.cPrinterName)
	ENDIF 
		
	* For the case of labels we'll not deal with merged reports
	IF LOWER(JUSTEXT(This._oReports(1))) = "lbx"
		lcReport = This._oReports(1)
		lcClauses = This._oClauses(1)
		LABEL FORM (lcReport) OBJECT loListener &lcClauses.
	ELSE
		LOCAL lcUser, n, lnCount
		lnCount = This._oReports.Count

		FOR n = 1 TO lnCount
			DO CASE
			CASE lnCount = 1 OR lnCount = n
				lcUser = ""
			OTHERWISE
				lcUser = "NOPAGEEJECT" && + " NORESET"
			ENDCASE
			lcReport = This._oReports(n)
			lcClauses = This._oClauses(n)

			IF tlKeepHandle
				IF n = lnCount
					loListener.WaitForNextReport = .F. && last report, allow closing
				ELSE 
					loListener.WaitForNextReport = .T.
				ENDIF 
			ENDIF
			
			REPORT FORM (lcReport) OBJECT loListener &lcClauses. &lcUser. 
		ENDFOR
	ENDIF 
ENDPROC

PROCEDURE RestorePrinter
	WITH This
		IF UPPER(._cOriginalPrinter) <> UPPER(SET("Printer",3)) && Current printer
			.SetPrinter(._cOriginalPrinter)
		ENDIF 
	ENDWITH 
ENDPROC 


PROCEDURE RunReport

	WITH This
		.lPrinted = .F.

		IF VARTYPE(.oListener) <> "O"
			* Create a PREVIEW listener
			TRY 
				.oListener = CREATEOBJECT(.cDefaultListener)
			CATCH
				.oListener = CREATEOBJECT("ReportListener")
			ENDTRY 
		ENDIF

*		DO (_ReportOutput) WITH 3, .oListener
		DO (ADDBS(HOME()) + "ReportOutput.App") WITH 3, .oListener

		.oListener.ListenerType = 1 && Preview

		LOCAL loPreviewContainer
		loPreviewContainer = NULL

		DO HOME() + "ReportPreview.App" WITH loPreviewContainer


		* Create an extension handler and hook it to the
		* preview container. This will let you manipulate
		* properties of the container and its Preview toolbar
		LOCAL loExHandler as ExtensionHandler OF SYS(16)
		loExHandler = NEWOBJECT('ExtensionHandler')
		loPreviewContainer.SetExtensionHandler(loExHandler)
		goHelper._oExHandler = loExHandler

		loPreviewContainer.ZoomLevel = goHelper.nZoomLevel
		loPreviewContainer.CanvasCount = goHelper.nCanvasCount

		* Link the Listener and preview container
		.oListener.PreviewContainer = loPreviewContainer

		* Run the report
		.CallReport()

		IF NOT goHelper._lNoWait
			This.DoOutput()
		ENDIF 

	ENDWITH 
	
ENDPROC 	


PROCEDURE DoOutput
	WITH This
		LOCAL lcFileFormat
		lcFileFormat = ""
		
		* Prepare the output file
		IF NOT EMPTY(.cDestFile) AND NOT .lSaved
			.lSaveToFile = .T.
			lcFileFormat = LOWER(JUSTEXT(.cDestFile))

			* 1st step, try to delete a file with the same name
			TRY 
				ERASE (.cDestFile)
			CATCH 
			ENDTRY 

		ENDIF

	ENDWITH

	DO CASE
		CASE This.lSaved

		CASE lcFileFormat = "pdf"
		* Using PDFx - by Luis Navas

		LOCAL lnType
		lnType = 1 && 1 = normal PDF, 2 = Image
		If lnType = 1 Then && Normal Pdf	
			Local loListener As "PdfListener" Of "PR_Pdfx.vcx"
			loListener = NewObject('PdfListener', 'PR_PDFx.vcx')
			loListener.cCodePage="CP1252" &&CodePage
		Else &&PDF As Image
			Local loListener As "PDFasImageListener" Of "PR_Pdfx.vcx"
			loListener = NewObject('PDFasImageListener', 'PR_PDFx.vcx')
		EndIf

		loListener.cTargetFileName = Alltrim(This.cDestFile)
		loListener.QuietMode   = .T.
		loListener.lCanPrint   = .T.
		loListener.lCanEdit    = .T.
		loListener.lCanCopy    = .T.
		loListener.lCanAddNotes= .T.
		loListener.lEncryptDocument = .F.
		loListener.cMasterPassword  = ""
		loListener.cUserPassword    = ""
		loListener.lOpenViewer      = .F.
		*To be Developed, not ready yet
		*	loListener.MergeDocument=.MergeDocument.Value
		*	loListener.MergeDocumentName=.MergeFileName.Value

		This.CallReport(loListener, .T.) && flag to keep opened till last report
		loListener = NULL

		IF NOT FILE(This.cDestFile)
			MESSAGEBOX(PR_ERR_CREATINGFILE, 0+16, PR_ERROR)
		ELSE
			This.lSaved = .T.
		ENDIF


	CASE INLIST(lcFileFormat, "htm", "html")
	
		LOCAL loListener2 as "HTMLListener" OF HOME() + "FFC/_ReportListener.vcx"
*		loListener2 = NEWOBJECT("HTMLListener", HOME() + "FFC/_ReportListener.vcx")
		loListener2 = NEWOBJECT("HTMLListener", "_ReportListener.vcx")

		loListener2.TargetFileName = This.cDestFile
		loListener2.QuietMode=.T.

		* Run the report
		This.CallReport(loListener2)
		loListener2 = NULL

		IF NOT FILE(This.cDestFile)
			MESSAGEBOX(PR_ERR_CREATINGFILE, 0+16, PR_ERROR)
		ELSE
			This.lSaved = .T.
		ENDIF

	CASE INLIST(lcFileFormat, "rtf", "doc")
		* Using RTFListener bt Vladimir Zhuravlev

		loRtfListener = NEWOBJECT("RTFreportlistener", "PR_RTFListener")
		loRtfListener.TargetFileName = This.cDestFile
*		loRtfListener.OutputType = 1

		This.CallReport(loRtfListener, .T.) && flag to keep opened till last report
		loRtfListener = NULL

		IF NOT FILE(This.cDestFile)
			MESSAGEBOX(PR_ERR_CREATINGFILE, 0+16, PR_ERROR)
		ELSE
			This.lSaved = .T.
		ENDIF

	CASE This._lSendToPrinter

		TRY 
			LOCAL loListener as ReportListener 
			TRY 
				loListener = CREATEOBJECT(This.cDefaultListener)
			CATCH
				loListener = CREATEOBJECT("ReportListener")
			ENDTRY
			loListener.ListenerType = 0 && Printer Output

			FOR n = 1 TO This.nCopies
				This.CallReport(loListener)
			ENDFOR 

			This.lPrinted = .T.
			This.RestorePrinter()

		CATCH TO loException
		ENDTRY 

	OTHERWISE 

	ENDCASE

	This.ReportReleased()

ENDPROC




PROCEDURE ReportReleased

	UNBINDEVENTS(This)
	DOEVENTS 
	* WAIT WINDOW ("Preview Closed" + CHR(13) + ;
		This.cPrinterName + CHR(13) + ;
		This._cFRXName) NOWAIT 

	* if changed, restore the printer to the original
	IF UPPER(This._cOriginalPrinter) <> UPPER(This.cPrinterName)
		This.SetPrinter(This._cOriginalPrinter)
	ENDIF 

	This.CloseProof()
	RELEASE goHelper

ENDPROC


PROCEDURE ClearCache
	* Trying to clear the report preview cache
	* If there is another Preview factory, disable it
	* http://spacefold.com/colin/archive/articles/reportpreview/rp_extend.html

	LOCAL lcFile
	lcFile = _ReportPreview

	TRY 
		_oReportOutput["1"].PreviewContainer = .NULL.
	CATCH 
	ENDTRY 

	* Prepare the new Report preview factory
	_ReportPreview = lcFile
	SET REPORTBEHAVIOR 90
ENDPROC 


PROCEDURE SetPrinter(tcPrinterName)
	LOCAL lcPrinter, llReturn
	llReturn  = .T. 
	lcPrinter = tcPrinterName
	TRY 
		SET PRINTER TO NAME '&lcPrinter'
	CATCH
		llReturn = .F.
	ENDTRY 
	RETURN llReturn
ENDPROC 


ENDDEFINE


*-------------------------
*-------------------------
DEFINE CLASS ExtensionHandler AS CUSTOM
	*-- Ref to the Preview Container's Preview Form
	PreviewForm  = NULL

	PROCEDURE STB_Handler(lEnabled)
		* Here you work around the setting
		* persistence problem in the Preview toolbar. 
		* The Preview toolbar class (frxpreviewtoolbar)
		* already has code that you can use to enforce
		* setting's persistence; it is just not called. Here,
		* you call it.
		WITH THIS.PreviewForm.TOOLBAR
			.REFRESH()
			* When you call frxpreviewtoolbar::REFRESH(), the
			* toolbar caption is set to its Preview form,
			* which differs from typical behavior. You must revert that
			* to be consistent. If you did not do this,
			* you would see " - Page 2" appended to the toolbar
			* caption if you skipped pages.
			.CAPTION = THIS.PreviewForm.formCaption
		ENDWITH
	ENDPROC


	PROCEDURE AddBarsToMenu( cPopup, iNextBar )
	* Rename the menu text to portuguese version
	* RELEASE BAR 8 OF (m.cPopup)

	DEFINE BAR 1 OF (m.cPopup) PROMPT PR_MENUTOP   PICTURE "pr_top.bmp"
	DEFINE BAR 2 OF (m.cPopup) PROMPT PR_MENUPREV  PICTURE "pr_previous.bmp"
	DEFINE BAR 3 OF (m.cPopup) PROMPT PR_MENUNEXT  PICTURE "pr_next.bmp"
	DEFINE BAR 4 OF (m.cPopup) PROMPT PR_MENULAST  PICTURE "pr_bottom.bmp" 
	DEFINE BAR 5 OF (m.cPopup) PROMPT PR_MENUGOTO  PICTURE "pr_gotopage.bmp" 
	DEFINE BAR 8 OF (m.cPopup) PROMPT PR_MENUSHOWPAGES 
	DEFINE BAR 10 OF (m.cPopup) PROMPT PR_MENUTOOLB 
	DEFINE BAR 13 OF (m.cPopup) PROMPT PR_MENUCLOSE  PICTURE "pr_close.bmp" 

	ON SELECTION BAR 5 OF (m.cPopup) ; 
		    oRef.ExtensionHandler.ActionGotoPage()

	ON SELECTION BAR 13 OF (m.cPopup) ; 
		    oRef.ExtensionHandler.ActionClose()

	ON SELECTION BAR 10 OF (m.cPopup) oRef.ExtensionHandler.actionToolbarVisibility()

	IF goHelper.lPrintVisible
	
        DEFINE BAR 15 ;
			OF (m.cPopup) ;
			PROMPT PR_MENUPRINT ;
			PICTURE "pr_print.bmp" 

        ON SELECTION BAR 15 OF (m.cPopup) ; 
		    oRef.ExtensionHandler.ActionPrint()

		* Printing preferences item
		IF goHelper.lPrinterPref
			DEFINE BAR 16 ;
				OF (m.cPopup) ;
				PROMPT PR_PRINTINGPREF ;
				PICTURE "pr_printPref.bmp" 

			ON SELECTION BAR 16 OF (m.cPopup) ; 
				oRef.ExtensionHandler.DoSetPrinterProps()
		ENDIF 

 
 		* Save to file item
		IF goHelper.lSaveToFile
	        DEFINE BAR 17 ;
				OF (m.cPopup) ;
				PROMPT PR_SAVEREPORT ;
				PICTURE "pr_Save.bmp" 

			LOCAL lcSaveMenu
			lcSaveMenu = SYS(2015)
	
			DEFINE POPUP (m.lcSaveMenu) SHORTCUT RELATIVE
			IF NOT goHelper.lExtended && Original report
	    	    ON SELECTION BAR 17 OF (m.cPopup) ; 
					oRef.ExtensionHandler.DoSaveType(1)
			ELSE 
	
				ON BAR 17 OF (m.cPopup) ACTIVATE POPUP &lcSaveMenu.
	
				DEFINE BAR 1 OF (lcSaveMenu) PROMPT PR_SAVEASIMAGE PICTURE "pr_Img.bmp"
				IF goHelper.lExtended
					DEFINE BAR 2 OF (lcSaveMenu) PROMPT PR_SAVEASPDF  PICTURE "pr_Pdf.bmp"
					DEFINE BAR 3 OF (lcSaveMenu) PROMPT PR_SAVEASHTML PICTURE "pr_Html.bmp"
					DEFINE BAR 4 OF (lcSaveMenu) PROMPT PR_SAVEASRTF  PICTURE "pr_Word.bmp"
				ENDIF 
				FOR n = 1 TO 4
					on Selection Bar n of (lcSaveMenu) oRef.ExtensionHandler.DoSaveType(BAR())
				ENDFOR 
			ENDIF 

	*        ON SELECTION BAR 17 OF (m.cPopup) ; 
		    oRef.ExtensionHandler.DoSave()
		ENDIF 
	ENDIF 



	* Show miniatures
	IF goHelper.lShowMiniatures
		DEFINE BAR 18 OF (m.cPopup) PROMPT '\-'

        DEFINE BAR 19 ;
			OF (m.cPopup) ;
			PROMPT PR_MENUPROOF ;
			PICTURE "pr_Locate.bmp" 

		* It is a documented fact that, at the time
		* the popup is activated, there is an object 
		* reference to the PreviewContainer instance
		* in scope in a variable called "oRef":
        ON SELECTION BAR 19 OF (m.cPopup) ; 
		    oRef.ExtensionHandler.DoProof()
	ENDIF 


	* Translating the Zoom and Page menu items for non English users
	#IFDEF PR_NONENGLISH

	PRIVATE lcZoom2, lcPages2
	lcZoom2  = SYS(2015)
	lcPages2 = SYS(2015)
	ON BAR 7 OF (m.cPopup) ACTIVATE POPUP &lcZoom2
	ON BAR 8 OF (m.cPopup) ACTIVATE POPUP &lcPages2

	*------------------------------------------------------
	* Define the Zoom popup: 
	* slightly adapted from the Report Preview project
	* the author of this piece of code is MS, (Lisa Slater Nicholls)
	* code extracted from the XSource.Zip file
	*------------------------------------------------------
	DEFINE POPUP (m.lcZoom2) SHORTCUT RELATIVE

	* Loop through all the array items, in case user is using a modified 
	* context menu (Joao Batista)
	*!*		oRef.ZoomLevels(10,1) = PR_CBOZOOMWHOLEPG
	*!*		oRef.ZoomLevels(11,1) = PR_CBOZOOMPGWIDTH

	LOCAL lcItem, i
	FOR i = 1 TO ALEN(oRef.ZoomLevels, 1) && Rows
		lcItem = LOWER(oRef.ZoomLevels(i, 1))
		IF lcItem = "whole page"
			oRef.ZoomLevels(i, 1) = PR_CBOZOOMWHOLEPG
		ENDIF
		IF lcItem = "fit to width"
			oRef.ZoomLevels(i, 1) = PR_CBOZOOMPGWIDTH
		ENDIF
	ENDFOR 

	for i = 1 to alen(oRef.ZoomLevels,1)
		define Bar m.i of(m.lcZoom2) prompt oRef.zoomLevels[m.i,1] && ZOOM_LEVEL_PROMPT
		on Selection Bar m.i of (m.lcZoom2) oref.actionSetZoom( bar() )
	endfor
	*---------------------- Set the mark:
	set mark of bar (oRef.ZoomLevel) of (m.lcZoom2) to .T.

	
	*------------------------------------------------------
	* Define the Page Count popup:
	*------------------------------------------------------
	DEFINE POPUP (m.lcPages2) SHORTCUT RELATIVE
	DEFINE BAR 1 OF (m.lcPages2) PROMPT PR_ONEPGMENU

	*---------------------- Disable multi-page view for high zoom levels:
	local iPagesAllowed
	iPagesAllowed = oRef.ZoomLevels[ oRef.zoomLevel, 3 ] && ZOOM_LEVEL_CANVAS
*	iPagesAllowed = MIN(goHelper.nPageTotal, iPagesAllowed)

	if m.iPagesAllowed > 1
		DEFINE BAR 2 OF (m.lcPages2) PROMPT PR_TWOPGMENU
	else
		DEFINE BAR 2 OF (m.lcPages2) PROMPT "\" + PR_TWOPGMENU
	endif
	if m.iPagesAllowed > 2
		DEFINE BAR 3 OF (m.lcPages2) PROMPT PR_FOURPGMENU
	else
		DEFINE BAR 3 OF (m.lcPages2) PROMPT "\" + PR_FOURPGMENU
	endif

	ON SELECTION BAR 1 OF (m.lcPages2) oRef.actionSetCanvasCount(1)		
	ON SELECTION BAR 2 OF (m.lcPages2) oRef.actionSetCanvasCount(2)
	ON SELECTION BAR 3 OF (m.lcPages2) oRef.actionSetCanvasCount(4)

	*---------------------- Set the mark:
	do case
	case oRef.canvasCount = 1
		set Mark of bar 1 of (m.lcPages2) to .T.
	case oRef.canvasCount = 2
		set Mark of bar 2 of (m.lcPages2) to .T.
	case oRef.canvasCount = 4
		set Mark of bar 3 of (m.lcPages2) to .T.
	endcase
	#ENDIF

	ENDPROC


	PROCEDURE CheckHelperClass
		IF VARTYPE(goHelper) <> "O"
			PUBLIC goHelper
			goHelper = CREATEOBJECT("PreviewHelper")
			goHelper.lExtended = .F.
		ENDIF 
	ENDPROC 


	PROCEDURE ActionToolbarVisibility
		*--------------------------------------------------
		* .ActionToolbarVisibility() - called from menu
		*--------------------------------------------------
		if isnull( THIS.PreviewForm.toolbar )
			THIS.PreviewForm.ToolbarIsVisible = .F.
			THIS.PreviewForm.CreateToolbar()
			This.UpdateToolbar()
		endif
		if THIS.PreviewForm.ToolbarIsVisible 
			* Hide the toolbar:
			THIS.PreviewForm.Toolbar.Hide()
			THIS.PreviewForm.ToolbarIsVisible = .F.
		else
			* Show the toolbar:
			THIS.PreviewForm.ShowToolbar(.T.)	
			THIS.PreviewForm.ToolbarIsVisible = .T.
		ENDIF
	ENDPROC 


	PROCEDURE ActionGoToPage
		*-----------------------------------------------------------
		* ActionGoToPage()
		*-----------------------------------------------------------
		#define WINDOWTYPE_MODELESS		0
		#define WINDOWTYPE_MODAL		1

		local loForm, iPageNo
		loForm = CREATEOBJECT("CustomFrxGotoPageForm")
		loForm.oParentForm = THIS.PreviewForm

		IF VARTYPE(THIS.PreviewForm.Toolbar) = "O"
			THIS.PreviewForm.ShowToolbar(.F.)
			loForm.Show( WINDOWTYPE_MODAL )
			THIS.PreviewForm.ShowToolbar(.T.)
		ELSE 
			loForm.Show( WINDOWTYPE_MODAL )		
		ENDIF 

		iPageNo = loForm.PageNo
		RELEASE m.loForm
		ACTIVATE WINDOW (THIS.PreviewForm.Name)

		IF m.iPageNo <> THIS.PreviewForm.currentPage
			THIS.PreviewForm.setCurrentPage( m.iPageNo )
		ENDIF 
	ENDPROC


	PROCEDURE ActionClose
		This.PreviewForm.oReport.OnPreviewClose(.F.)
	ENDPROC

	PROCEDURE ActionPrint
		This.PreviewForm.oReport.OnPreviewClose(.T.)
	ENDPROC


	PROCEDURE Show(iStyle)

		* Ensure that we have a parent helper class
		This.CheckHelperClass()

		WITH This.PreviewForm
			LOCAL llNoWait, llTopForm

			TRY
				llTopForm = This.PreviewForm.TopForm && to avoid the error "TopForm" property does not exist
			CATCH
			ENDTRY 
						
			llNowait = llTopForm or ;
				This.PreviewForm.oReport.CommandClauses.NoWait
			goHelper._lNoWait = llNowait

			* This.PreviewForm.oReport.CommandClauses.InWindow = ""

			LOCAL loListener
			loListener = This.PreviewForm.oReport

			goHelper.nPageTotal = .PageTotal
			goHelper._cFRXName  = .FrxFileName
		*!*	goHelper._cFRXFullName = loListener.CommandClausesFile

			* Retrieve report clauses
			goHelper._ClausenRangeFrom = loListener.CommandClauses.RangeFrom
			goHelper._ClausenRangeTo = loListener.CommandClauses.RangeTo && -1 = All pages
			goHelper._ClauselSummary = loListener.CommandClauses.Summary 
			goHelper._ClausecHeading = loListener.CommandClauses.Heading

		ENDWITH 

		This.UpdateToolBar()

		DODEFAULT(iStyle)
	ENDPROC

	*!* Only works after SP1, so we keep calling "UpdateToolbar()" directly
	*!*	PROCEDURE InitializeToolBar()
	*!*		This.UpdateToolBar()
	*!*	ENDPROC 


	PROCEDURE UpdateToolBar

		With This.PreviewForm
			.AllowPrintfromPreview = .F. && Force this value, 
				&& dont worry, because we'll add manually a new "Print" button

			IF NOT goHelper.lExtended
				BINDEVENT(This, "Destroy", goHelper, "ReportReleased")
			ENDIF 

			IF NOT EMPTY(goHelper.cTitle)
				This.PreviewForm.formCaption = goHelper.cTitle + ;
					IIF(NOT goHelper.lExtended, "", ;
						IIF(goHelper._oReports.Count > 1, "", ;
							SPACE(5) + "-" + SPACE(5) + goHelper._cFRXName))
				This.PreviewForm.Caption = goHelper.cTitle + " - " + goHelper._cFRXName
			ENDIF 

			With .Toolbar as Toolbar

* Not used any more, to prevent adding twice the same obj to the toolbar
*!*					IF PEMSTATUS(This.PreviewForm.Toolbar, "lStarted", 5)
*!*						RETURN
*!*					ELSE
*!*						This.PreviewForm.Toolbar.AddProperty("lStarted", .T.)
*!*					ENDIF 

				IF goHelper.lShowMiniatures && shows the miniatures page
					.AddObject("cmdProof1","cmdProof")
				ENDIF 

				LOCAL loCombo as ComboBox
				loCombo = .cboZoom


			#IFDEF PR_NONENGLISH

				* Replace the GoToPage button
				.cntPrev.AddObject("cmdGoto1", "cmdGotoEx")
				.cmdGotoPage.Visible = .F.

				* Translate toolbar buttons ToolTips to non English language
				.cboZoom.ToolTipText = "Zoom"

				* Translate the combo items
				LOCAL n, lcItem
				FOR n = 1 TO loCombo.ListCount
					lcItem = LOWER(loCombo.ListItem(n))
					IF lcItem = "whole page"
						loCombo.ListItem(n) = PR_CBOZOOMWHOLEPG
					ENDIF
					IF lcItem = "fit to width"
						loCombo.ListItem(n) = PR_CBOZOOMPGWIDTH
					ENDIF
				ENDFOR
				loCombo.Width = loCombo.Width + 10

				.cmdGoToPage.ToolTipText = PR_CMDGOTOPGTTIP

				With .opgPageCount
					.opt1.ToolTipText = PR_ONEPGTTIP
					.opt2.ToolTipText = PR_TWOPGTTIP
					.opt3.ToolTipText = PR_FOURPGTTIP
				ENDWITH

				WITH .cntNext
					.cmdBottom.ToolTipText  = PR_MENULAST
					.cmdForward.ToolTipText = PR_MENUNEXT
				ENDWITH 

				WITH .cntPrev
					.cmdBack.ToolTipText = PR_MENUPREV
					.cmdTop.ToolTipText  = PR_MENUTOP
				ENDWITH
				
			#ENDIF

				With .cntNext
					.cmdBottom.Picture      = "pr_bottom.bmp"
					.cmdForward.Picture     = "pr_next.bmp"
				Endwith

				With .cntPrev
					.cmdBack.Picture     = "pr_previous.bmp"
					.cmdTop.Picture      = "pr_top.bmp"
				Endwith
				.Refresh()
				
			IF goHelper.lPrintVisible
			
				.AddObject("cmbPrinters1", "cmbPrinters")
				.cmbPrinters1.Height = loCombo.Height
				.cmbPrinters1.FontSize = loCombo.FontSize

				* Show the Printer preferences button
				IF goHelper.lPrinterPref AND goHelper.lExtended
					.AddObject("cmdPrinterProps1", "cmdPrinterProps")
				ENDIF 

				* Show the copies spinner
				IF goHelper.lShowCopies AND goHelper.lExtended
					.AddObject("cntCopies1","cntCopies")
					.cntCopies1.SpnCopies1.FontSize = loCombo.FontSize
					.cntCopies1.LblCopies1.FontSize = loCombo.FontSize
				ENDIF  && goHelper.lShowCopies

				* Show the Save to file button
				IF goHelper.lSaveToFile && AND goHelper.lExtended
					.AddObject("cmdSave1", "cmdSave")
				ENDIF  && goHelper.lSaveToFile

				* Show the Send to Email button
				IF goHelper.lSendToEmail AND goHelper.lExtended
					.AddObject("cmdEmail1", "cmdEmail")
				ENDIF && goHelper.lSendToEmail

				* Replace the original Print button
				.AddObject("cmdPrint1", "cmdPrintEx")
				#IFDEF PR_NONENGLISH
					.cmdPrint1.ToolTipText = PR_PRINTREPORT
				#ELSE
					.cmdPrint1.ToolTipText = .cmdPrint.ToolTipText
				#ENDIF

			ENDIF

			* Replace the original Close button
			.cmdClose.Visible = .F.
			.AddObject("cmdExit1", "cmdExit")
			#IFDEF PR_NONENGLISH
				.CmdExit1.ToolTipText  = PR_CLOSEREPORT
			#ELSE
				.CmdExit1.ToolTipText  = .cmdClose.ToolTipText
			#ENDIF

			ENDWITH 

		ENDWITH 

	ENDPROC 


	PROCEDURE DoProof()
		goHelper._oProofSheet = CREATEOBJECT("ProofSheet")
		goHelper._oProofSheet.SetReport( THIS.PreviewForm.oReport )
		goHelper._oProofSheet.Caption = PR_GLOBALPREVIEW
		goHelper._oProofSheet.Show(1)
		* read the selected page and move to it, 
		* using the .SetCurrentPage() method of 
		* the default preview container:
		TRY 
			THIS.PreviewForm.SetCurrentPage( goHelper._oProofSheet.Currentpage )
			goHelper._oProofSheet = ""
		CATCH 
		ENDTRY 
	ENDPROC


	PROCEDURE DoSave()

		IF NOT goHelper.lExtended && Original report
			This.DoSaveType(1) && Allow only saving as image
		ELSE 
			* Ensure the proof sheet is closed
			goHelper.CloseProof()

			LOCAL lcSaveMenu, lnOption
			lnOption = 0
			lcSaveMenu = SYS(2015)


			IF This.PreviewForm.ShowWindow = 0 && In _Screen
				LOCAL loForm as Form
				loForm = _Screen

				LOCAL lcPoint, x, y
				lcPoint = SPACE(8)
				=PR_GetCursorPos(@lcPoint)
				=PR_ScreenToClient(loForm.hWnd, @lcPoint)
				x = CTOBIN(LEFT(lcPoint,4), "4RS")  /(loForm.width/scols())
				y = CTOBIN(RIGHT(lcPoint,4), "4RS") /(loFOrm.height/srows())

				ACTIVATE SCREEN
				DEFINE POPUP (lcSaveMenu) FROM y,x SHORTCUT RELATIVE MARGIN
			ELSE 
				DEFINE POPUP (lcSaveMenu) SHORTCUT RELATIVE FROM MROW(), MCOL()
			ENDIF 

			ACTIVATE WINDOW (THIS.PreviewForm.Name)

*!*			DEFINE POPUP myshortcut shortcut RELATIVE FROM MROW(),MCOL()
*!*			DEFINE BAR 1 OF myshortcut PROMPT "sm1" 
*!*			DEFINE BAR 2 OF myshortcut PROMPT "sm2"
*!*			DEFINE BAR 3 OF myshortcut PROMPT "am3"
*!*			ACTIVATE POPUP myshortcut		

			DEFINE BAR 1 OF (lcSaveMenu) PROMPT PR_SAVEASIMAGE PICTURE "pr_Img.bmp"
			IF goHelper.lExtended
				DEFINE BAR 2 OF (lcSaveMenu) PROMPT PR_SAVEASPDF  PICTURE "pr_Pdf.bmp"
				DEFINE BAR 3 OF (lcSaveMenu) PROMPT PR_SAVEASHTML PICTURE "pr_Html.bmp"
				DEFINE BAR 4 OF (lcSaveMenu) PROMPT PR_SAVEASRTF  PICTURE "pr_Word.bmp"
			ENDIF 
			ON SELECTION POPUP (lcSaveMenu) lnOption = BAR()

			ACTIVATE POPUP (lcSaveMenu)

			IF lnOption = 0
				RETURN
			ENDIF 

			This.DoSaveType(lnOption)
		ENDIF 

		IF goHelper._lNoWait
			goHelper.DoOutput()
		ENDIF 
	ENDPROC



	PROCEDURE DoSaveType(tnType)

		LOCAL lcFile
		lcFile = ""
		
		DO CASE
		CASE tnType = 1 && Image file
			lcFile = PUTFILE(PR_SAVEASIMAGE + "...", "", ;
				"Png;Bmp;Jpg;Gif;Tif;Emf")
			IF NOT EMPTY(lcFile) && Invalid File Name
				LOCAL loListener
				loListener = This.PreviewForm.oReport
				goHelper.lSaved = Report2Pic(loListener, lcFile, JUSTEXT(lcFile))
			ENDIF

		CASE tnType = 2 && PDF
			lcFile = PUTFILE(PR_SAVEASPDF + "...", "", "Pdf")

		CASE tnType = 3 && HTML
			lcFile = PUTFILE(PR_SAVEASHTML + "...", "", "Htm;Html")

		CASE tnType = 4 && RTF
			lcFile = PUTFILE(PR_SAVEASRTF + "...", "", "Rtf;Doc")

		OTHERWISE 

		ENDCASE

		IF NOT EMPTY(lcFile) && Invalid File Name
			goHelper.cDestFile = lcFile
			
			* Close the preview form completely
			This.PreviewForm.oReport.OnPreviewClose(.F.)
		ENDIF
	ENDPROC 


	PROCEDURE DoSetPrinterProps()
		IF UPPER(goHelper._cOriginalPrinter) <> UPPER(goHelper.cPrinterName)
			goHelper.SetPrinter(goHelper.cPrinterName)
		ENDIF 
		DO SetPrinterProps
	ENDPROC 


	PROCEDURE HandledKeyPress( nKeyCode, nShiftAltCtrl )
		RETURN .F.
	ENDPROC

	PROCEDURE PAINT
	ENDPROC

	PROCEDURE RELEASE
		RETURN .T.
	ENDPROC 
ENDDEFINE
*-- END CODE


* Included controls classes
DEFINE CLASS cmdReport AS CommandButton
	Caption = ""
	Width   = 24
	Height  = 22
	SpecialEffect = 2 && Hot tracking
ENDDEFINE

DEFINE CLASS cntCopies AS Container
	BackStyle = 0 && Transparent					
	BorderWidth = 0
	Height = 23
	Width = 50
	Visible = .T.
	
	ADD OBJECT spnCopies1 AS spnCopies
	ADD OBJECT lblCopies1 AS lblCopies
	
	PROCEDURE Init
		This.lblCopies1.Left = 3
		This.lblCopies1.Top  = 2
		This.spnCopies1.Left = 3 + This.lblCopies1.Width 
		This.Width = 3 + This.lblCopies1.Width + 2 + This.spnCopies1.Width + 1
	ENDPROC 
ENDDEFINE


DEFINE CLASS spnCopies AS Spinner
	Width   = 42
	Height  = 22
	SpecialEffect = 2 && Hot tracking
	Increment = 1
	SpinnerHighValue = 99
	SpinnerLowValue = 1	
	KeyboardHighValue = 99
	KeyboardLowValue = 1
	ToolTipText = PR_COPIES
	Visible = .T.

	PROCEDURE Init
		This.Value = goHelper.nCopies
	ENDPROC

	PROCEDURE InteractiveChange
		goHelper.nCopies = This.Value
	ENDPROC
ENDDEFINE


DEFINE CLASS lblCopies AS Label
	Caption = PR_COPIES 
	AutoSize = .T.
	BackStyle = 0 && Transparent					
	Visible = .T.
ENDDEFINE


DEFINE CLASS cmdSave AS cmdReport
	ToolTipText = PR_SAVEREPORT
	Picture     = "pr_save.bmp"
	Visible     = .T.

	PROCEDURE Click
		This.Parent.PreviewForm.ExtensionHandler.DoSave()
	ENDPROC
	
	PROCEDURE RightClick

*!*			DEFINE POPUP myshortcut shortcut RELATIVE FROM MROW(),MCOL()
*!*			DEFINE BAR 1 OF myshortcut PROMPT "sm1" 
*!*			DEFINE BAR 2 OF myshortcut PROMPT "sm2"
*!*			DEFINE BAR 3 OF myshortcut PROMPT "am3"
*!*			ACTIVATE POPUP myshortcut		

*!*			DECL INTEGER GetCursorPos in user32 AS Api_GetCursorPos STRING @
*!*			DECL INTEGER ScreenToClient in user32 AS Api_ScreenToClient integer, STRING @

*!*			LOCAL lcPoint
*!*			lcPoint=SPACE(8)
*!*			=Api_GetCursorPos(@lcPoint)
*!*			=Api_ScreenToClient(_screen.hWnd, @lcPoint)
*!*			x = Str2Long(LEFT(lcPoint,4))/(_screen.width/scols())
*!*			y = Str2Long(RIGHT(lcPoint,4))/(_screen.height/srows())

*!*			ACTIVATE SCREEN
*!*			DEFI POPU mnu FROM y,x SHOR rela marg
*!*			DEFI BAR 1 OF mnu PROM 'Bar 1'
*!*			DEFI BAR 2 OF mnu PROM 'Bar 2'
*!*			ACTIVATE POPUP mnu
	ENDPROC 

ENDDEFINE


DEFINE CLASS cmdPrinterProps AS cmdReport
	ToolTipText = PR_PRINTINGPREF
	Picture     = "pr_printPref.bmp"
	Visible     = .T.

	PROCEDURE Click
		This.Parent.PreviewForm.ExtensionHandler.DoSetPrinterProps()
	ENDPROC
ENDDEFINE


DEFINE CLASS cmdEmail AS cmdReport
	ToolTipText = PR_SENDTOEMAIL
	Picture     = "pr_Mail.bmp"
	Visible     = .T.

	PROCEDURE Click
		* Ensure the proof sheet is closed
		goHelper.CloseProof()
		MESSAGEBOX("Feature not available yet", 48, "Wait for the next update!")
		RETURN 
	ENDPROC

ENDDEFINE


DEFINE CLASS cmdExit AS cmdReport
	Picture     = "pr_close.bmp"
	Visible     = .T.

	PROCEDURE Click
		* Hide the Preview form
		This.Parent.PreviewForm.Visible = .F.
		goHelper.lPrinted = .F.

		* Ensure the proof sheet is closed
		goHelper.CloseProof()

		* Close the report window
		This.Parent.cmdClose.Click()
	ENDPROC

	PROCEDURE MouseEnter
		LPARAMETERS nButton, nShift, nXCoord, nYCoord
		This.Picture = "pr_close2.bmp"
	ENDPROC

	PROCEDURE MouseLeave
		LPARAMETERS nButton, nShift, nXCoord, nYCoord
		This.Picture = "pr_close.bmp"
	ENDPROC

	PROCEDURE Init
		This.Width = This.Parent.cmdClose.Width
	ENDPROC 

ENDDEFINE



DEFINE CLASS cmdPrintEx AS cmdReport
	Picture     = "pr_print.bmp"
	Visible     = .T.

	PROCEDURE Init 
		#IFDEF PR_NONENGLISH
			This.ToolTipText = PR_PRINTREPORT
		#ELSE
			This.ToolTipText = This.Parent.cmdPrint.ToolTipText
		#ENDIF
	ENDPROC 


	PROCEDURE Click

		* Ensure the proof sheet is closed
		goHelper.CloseProof()

		IF ALLTRIM(UPPER(goHelper.cPrinterName)) = ALLTRIM(UPPER(goHelper._cOriginalPrinter))
		&& Default printer not changed, go ahead with the default behavior	
			* Do the default behavior
			* Hide the Preview form
			This.Parent.PreviewForm.Visible = .F.

			* Print the current report
			goHelper.lPrinted = .T.
			
			* Decrease the nCopies property
			goHelper.nCopies = goHelper.nCopies - 1
			goHelper._lSendToPrinter = .T.
			This.Parent.PreviewForm.oReport.OnPreviewClose(.T.)

*!*				IF NOT goHelper.lExtended
*!*					This.Parent.PreviewForm.ToolBar = NULL
*!*				ENDIF 

			IF NOT goHelper.lExtended
				goHelper.ClearCache()
			ENDIF 

		ELSE 
			&& Changed the printer, so finish the preview and
			&& print from outside the preview window
			goHelper._lSendToPrinter = goHelper.SetPrinter(goHelper.cPrinterName)
			This.Parent.PreviewForm.oReport.OnPreviewClose(.F.)
		ENDIF 
	
		IF goHelper._lNoWait
			goHelper.DoOutput()
		ENDIF 
	
	ENDPROC

	PROCEDURE Init
		This.Width = This.Parent.cmdPrint.Width
	ENDPROC 
ENDDEFINE


DEFINE CLASS cmdGotoEx AS cmdReport
	Picture     = "pr_GotoPage.bmp"
	Visible     = .T.

	PROCEDURE Init 
		LOCAL loOrigGoto as CommandButton 
		loOrigGoto = This.Parent.Parent.cmdGotoPage

		#IFDEF PR_NONENGLISH
			This.ToolTipText = PR_CMDGOTOPGTTIP
		#ELSE
			This.ToolTipText = loOrigGoto.ToolTipText
		#ENDIF
		This.Left = This.Parent.Width
		This.Height = loOrigGoto.Height
		This.Width = loOrigGoto.Width
		This.Parent.Width = This.Parent.Width + This.Width
	ENDPROC 

	PROCEDURE Click
		This.Parent.Parent.PreviewForm.ExtensionHandler.ActionGotoPage()
	ENDPROC

ENDDEFINE


DEFINE CLASS cmbPrinters AS Combobox
	Width = 190
	ColumnCount = 2
	ColumnLines = .F.
	RowSourceType = 0 && None
	ColumnWidths = "200,130"
	Style = 2 && DropDown List
	ToolTipText = PR_AVAILABLEPRINT
	Visible = .T.
	_cOriginalPrinter = ""

	PROCEDURE Init

		LOCAL ARRAY laPrinters(1)
		=APRINTERS(laPrinters)

		LOCAL lcDefPrintern, lcCurrPrinter, n
		lcDefPrinter = SET("Printer",3)

		WITH This as ComboBox

			FOR n = 1 TO ALEN(laPrinters) STEP 2
				lcCurrPrinter = laPrinters(n)
				IF UPPER(ALLTRIM(lcDefPrinter)) = UPPER(ALLTRIM(lcCurrPrinter))
					lcDefPrinter = lcCurrPrinter
					.AddItem(lcCurrPrinter)
					.List(.NewIndex, 2) = laPrinters(n+1)
					EXIT 
				ENDIF
			ENDFOR

			FOR n = 1 TO ALEN(laPrinters) STEP 2
				lcCurrPrinter = laPrinters(n)
				IF NOT (UPPER(ALLTRIM(lcDefPrinter)) = UPPER(ALLTRIM(lcCurrPrinter)))
					.AddItem(lcCurrPrinter)
					.List(.NewIndex, 2) = laPrinters(n+1)
				ENDIF
			ENDFOR

			* .Value = lcDefPrinter
			.ListIndex = 1
			._cOriginalPrinter = lcDefPrinter

			LOCAL lcItem
			FOR n = 1 TO .ListCount
				lcItem = .List(n,1)
				IF LEFT(lcItem,1) = "\"
					.List(n,1) = "\\" + lcItem
				ENDIF 
			
				lcItem = .List(n,2)
				IF LEFT(lcItem,1) = "\"
					.List(n,2) = "\\" + lcItem
				ENDIF 
			ENDFOR 

		ENDWITH
	
		IF goHelper.lExtended = .F.
			BINDEVENT(This, "Enabled", This, "DisableCombo", 1)
		ENDIF 

	ENDPROC

	PROCEDURE DisableCombo
		This.Enabled = .F.		
	ENDPROC 


	PROCEDURE Valid
		LOCAL lcValue, lcOrigPrinter
		lcValue = This.Value
		lcOrigPrinter = goHelper._cOriginalPrinter

		IF LEFT(lcValue,1) = "\" AND SUBSTR(lcValue,2,1) <> "\" 
			lcValue = "\" + lcValue
		ENDIF 
		
		IF ALLTRIM(UPPER(lcValue)) <> ALLTRIM(UPPER(lcOrigPrinter))
			goHelper.cPrinterName = lcValue
		ENDIF 
	ENDPROC

ENDDEFINE

DEFINE CLASS cmdProof AS CmdReport
   Picture = "pr_Locate.bmp"
   ToolTipText = PR_MINIATURES
   Visible = .T.
   
   PROCEDURE Click()
      THIS.Parent.PreviewForm.ExtensionHandler.DoProof()
   ENDPROC
ENDDEFINE



* Helper functions
PROCEDURE Report2Pic(toListener, tcDestFile, tcFileFormat)

	IF VARTYPE(toListener) <> "O"
		ERROR "Report Listener could not be accessed"
		RETURN .F.
	ENDIF

	IF VARTYPE(tcFileFormat) = "L"
		tcFileFormat = JUSTEXT(tcDestFile)
	ENDIF
	tcFileFormat = LOWER(tcFileFormat)

	LOCAL lnPageCount, lnFileType, lnDeviceType
	lnPageCount = goHelper.nPageTotal && toListener.PageTotal

	DO CASE
	*!*	100 - imagem de tipo EMF
	*!*	101 - imagem de tipo TIFF
	*!*	102 - imagem de tipo JPEG
	*!*	103 - imagem de tipo GIF
	*!*	104 - imagem de tipo PNG
	*!*	105 - imagem de tipo BMP

	CASE tcFileFormat = "emf"
		lnFileType = 100

	CASE tcFileFormat = "tiff" OR tcFileFormat = "tif"
		lnFileType = 101

		#define OutputNothing -1
		#define OutputTIFF 101
		#define OutputTIFFAdditive (OutputTIFF+100)

		LOCAL lnPageNo
		FOR lnPageNo = 1 TO lnPageCount
			IF (lnPageNo == 1)
				lnDeviceType = OutputTIFF
			ELSE
				lnDeviceType = OutputTIFFAdditive
			ENDIF
			toListener.OutputPage(lnPageNo,tcDestFile,lnDeviceType)
		ENDFOR
		RETURN


	CASE tcFileFormat = "jpeg" OR tcFileFormat = "jpg"
		lnFileType = 102

	CASE tcFileFormat = "gif"
		lnFileType = 103

	CASE tcFileFormat = "png"
		lnFileType = 104

	CASE tcFileFormat = "bmp" OR  tcFileFormat = "bitmap"
		lnFileType = 105

	ENDCASE

	* Assegurarse de que no existe o arquivo grfico
	ERASE (tcDestFile)

	LOCAL lcPathFile, lcDestFile, lcIndex, llSuccess
	llSuccess = .T.
	lcPathFile = ADDBS(JUSTPATH(tcDestFile)) + JUSTSTEM(tcDestFile)

	FOR lnPageNo = 1 TO lnPageCount
		IF lnPageCount = 1
			lcIndex = ""
		ELSE
			lcIndex = TRANSFORM(lnPageNo)
		ENDIF
		lcDestFile = FORCEEXT((lcPathFile + lcIndex),tcFileFormat)
		toListener.OutputPage(lnPageNo, lcDestFile, lnFileType)
		IF NOT FILE(lcDestFile)
			llSuccess = .F.
		ENDIF 
	ENDFOR
	RETURN llSuccess
ENDPROC





**************************************************
*-- Class:        frxgotopageform
*-- ParentClass:  frmReport
*-- BaseClass:    form
*
DEFINE CLASS CustomFrxGotoPageForm AS frmReport

	Height = 92
	Width = 345
	ShowWindow = 1
	DoCreate = .T.
	AutoCenter = .T.
	BorderStyle = 2
	Closable = .F.
	MaxButton = .F.
	MinButton = .F.
	AlwaysOnTop = .T.
	AllowOutput = .F.
	*-- Provides the current page number for report output.
	pageno = 0
	*-- Provides a PageTotal for report output.
	pagetotal = 0
	oparentform = (.NULL.)
	Name = "frxgotopageform"

	ADD OBJECT shp1 AS shape WITH ;
		Top = 15, ;
		Left = 12, ;
		Height = 66, ;
		Width = 224, ;
		BackStyle = 0, ;
		ZOrderSet = 0, ;
		Style = 3, ;
		Name = "Shp1"

	ADD OBJECT spnpageno AS spinner WITH ;
		Height = 21, ;
		InputMask = "9999", ;
		Left = 64, ;
		Top = 36, ;
		Width = 126, ;
		ZOrderSet = 1, ;
		Name = "spnPageno"

	ADD OBJECT lblcaption AS label WITH ;
		Left = 20, ;
		Top = 8, ;
		ZOrderSet = 2, ;
		Style = 3, ;
		Name = "lblCaption", ;
		Autosize = .T.

	ADD OBJECT cmdok AS cmdReport WITH ;
		Top = 15, ;
		Left = 248, ;
		Width = 84, ;
		Height = 25, ;
		Default = .T., ;
		ZOrderSet = 3, ;
		Name = "cmdOK", ;
		SpecialEffect = 0 && 3D


	ADD OBJECT cmdcancel AS cmdReport WITH ;
		Top = 47, ;
		Left = 248, ;
		Width = 84, ;
		Height = 25, ;
		Cancel = .T., ;
		ZOrderSet = 4, ;
		Name = "cmdCancel", ;
		SpecialEffect = 0 && 3D


	PROCEDURE Show
		LPARAMETERS nStyle
		*-----------------------------------------
		* Fix for SP1: Handle positioning in top-level form
		* See frxPreviewForm::ActionGoToPage()
		* Addresses bug# 474691
		*-----------------------------------------
		THIS.pageNo    = THIS.oParentForm.currentPage
		THIS.pageTotal = THIS.oParentForm.pageTotal
		THIS.Caption   = PR_REPORTTITLE
		THIS.lblCaption.Caption = PR_GOTOPG_CAPTION + " (1-" + transform(THIS.pageTotal) + ")"

		if THIS.oParentForm.ShowWindow = 2 && as top-level form
			*-----------------------------------
			* If parent preview window is a top-level form,
			* center the child window in the view port:
			*-----------------------------------
			THIS.AutoCenter = .F.
			THIS.Left = THIS.oParentForm.ViewPortLeft + int(THIS.oParentForm.Width/2  - THIS.Width/2)  
			THIS.Top  = THIS.oParentForm.ViewPortTop  + int(THIS.oParentForm.Height/2 - THIS.Height/2)
		else
			THIS.AutoCenter = .T.
		endif
		*--------------

		THIS.spnPageNo.SpinnerLowValue = 1
		THIS.spnPageNo.SpinnerHighValue = THIS.pageTotal

		THIS.spnPageNo.KeyboardLowValue = 1
		THIS.spnPageNo.KeyboardHighValue = THIS.pageTotal

		THIS.spnPageNo.Value = THIS.pageNo

		dodefault(m.nStyle)
	ENDPROC

	PROCEDURE Init
		THIS.cmdOK.Caption     = PR_GOTOPG_OK
		THIS.cmdCancel.Caption = PR_GOTOPG_CANCEL
	ENDPROC

	PROCEDURE spnpageno.LostFocus
		if THIS.Value < THIS.SpinnerLowValue
			THIS.Value = 1
		endif
		if THIS.Value > THIS.SpinnerHighValue
			THIS.Value = THIS.SpinnerHighValue
		endif
		dodefault()
	ENDPROC

	PROCEDURE cmdok.Click
		THIS.Parent.pageNo = THIS.Parent.spnPageNo.Value
		THIS.Parent.Hide()
	ENDPROC

	PROCEDURE cmdcancel.Click
		THIS.Parent.Hide()
	ENDPROC

ENDDEFINE
*-- EndDefine: frxgotopageform
**************************************************


**************************************************
*-- Class:        frmReport
*-- ParentClass:  form
*-- BaseClass:    form
*-- Author:       CChalom
DEFINE CLASS frmReport AS Form
	icon = "wwrite.ico"
ENDDEFINE
*-- EndDefine: frxgotopageform
**************************************************


**************************************************
*-- Class:        proofshape
*-- ParentClass:  shape
*-- BaseClass:    shape
*-- Author:       Colin Nicholls
DEFINE CLASS proofshape AS shape
	Height = 110
	Width = 85
	*-- Provides the current page number for report output.
	pageno = 0
	Name = "proofshape"

	PROCEDURE MouseLeave
		LPARAMETERS nButton, nShift, nXCoord, nYCoord
		This.MousePointer = 0 && Default
		*This.ResetToDefault("BorderColor")
	ENDPROC

	PROCEDURE MouseEnter
		LPARAMETERS nButton, nShift, nXCoord, nYCoord
		This.MousePointer = 15 && Hand
		*This.BorderColor = RGB(255,0,0) && Red
		This.Parent.nCurrShape = This.PageNo
	ENDPROC

	PROCEDURE Click
		THISFORM.CurrentPage = THIS.PageNo
		THISFORM.Hide()
		activate screen
	ENDPROC
ENDDEFINE
*-- EndDefine: proofshape
**************************************************


**************************************************
*-- Class:        proofsheet
*-- ParentClass:  form
*-- BaseClass:    form
*-- Author:       Colin Nicholls
DEFINE CLASS proofsheet AS frmReport
	Height = 274
	Width = 622
	ScrollBars = 3
	DoCreate = .T.
	AutoCenter = .T.
	currentpage = 0
	reportlistener = .NULL.
	lstarted = .F.
	npages = 1
	lpainted = .F.
	ncurrshape = 0
	Name = "proofsheet"

	PROCEDURE setreport
		lparameters oReport
		THIS.ReportListener = m.oReport
		This.nPages = m.oReport.OutputPageCount
	ENDPROC

	PROCEDURE Resize
		This.Show()
	ENDPROC

	PROCEDURE QueryUnload
		THIS.Hide()
		activate screen
	ENDPROC

	PROCEDURE Paint
		if (not isnull(THIS.ReportListener))
			for i = 1 to min(64, This.nPages)
				THIS.ReportListener.OutputPage( m.i, THIS.Objects[m.i],2)
			endfor
		endif
	ENDPROC

	PROCEDURE Show
		LPARAMETERS nStyle
		#define SPACE_PIXELS 10

		iRowOffset = SPACE_PIXELS
		iColOffset = SPACE_PIXELS
		iColCount  = INT((Thisform.Width - iColOffset)/ 95) && 6
		for i = 1 to min(64,This.nPages)
			IF NOT This.lStarted
				THIS.AddObject(sys(2015),"ProofShape")
				THIS.Objects[i].Visible = .T.
				THIS.Objects[i].PageNo = m.i
			ENDIF 

			* Arrange shapes on form:
			TRY 
				THIS.Objects[i].Top  = iRowOffset
				THIS.Objects[i].Left = iColOffset
				if mod(m.i,iColCount) = 0
					iRowOffset = iRowOffset + SPACE_PIXELS + THIS.Objects[m.i].Height
					iColOffset = SPACE_PIXELS
				else
					iColOffset = iColOffset + THIS.Objects[i].Width + SPACE_PIXELS
				endif
			CATCH 
			ENDTRY 
		ENDFOR 
		This.lStarted = .T.
		dodefault(nStyle)
	ENDPROC

	PROCEDURE Destroy
		THIS.ReportListener = null
	ENDPROC
ENDDEFINE
*-- EndDefine: proofsheet
**************************************************



*********************************************************************
FUNCTION PR_ScreenToClient(hWND, cPoint)
*********************************************************************
	DECLARE INTEGER ScreenToClient in user32 AS PR_ScreenToClient INTEGER hWND, STRING @cPoint
	RETURN PR_ScreenToClient(m.hWND, @m.cPoint)
ENDFUNC

*********************************************************************
FUNCTION PR_GetCursorPos(cPoint)
*********************************************************************
	DECLARE INTEGER GetCursorPos in user32 AS PR_GetCursorPos STRING @cPoint
	RETURN PR_GetCursorPos(@m.cPoint)
ENDFUNC

*********************************************************************
PROCEDURE SetPrinterProps
*********************************************************************
* Code from Barbara Peisch
* Allows changing the current priner settings
* Using the Printer perferences dialog
* http://www.foxite.com/archives/0000158197.htm

	* Lets the user set all possible printer properties
	LOCAL lcRptFile, lhWindow, lcOrigDevMode, lcModifiedDevMode, lcPrinter, lhPrinter

	* These constants come from the Windows.h file
	#DEFINE IDOK     1
	#DEFINE IDCANCEL 2

	#DEFINE DM_OUT_BUFFER 2
	#DEFINE DM_IN_BUFFER  8
	#DEFINE DM_IN_PROMPT  4

	DECLARE INTEGER OpenPrinter IN winspool.drv ;
		STRING pPrinterName, ;
		INTEGER @phPrinter, ;
		INTEGER pDefault

	DECLARE INTEGER GetActiveWindow IN user32

	DECLARE INTEGER DocumentProperties IN winspool.drv ;
		INTEGER hWnd, ;
		INTEGER hPrinter, ;
		STRING pDeviceName, ;
		STRING @pDevModeOutput, ;
		STRING @pDevModeInput, ;
		INTEGER fMode

	DECLARE INTEGER ClosePrinter IN winspool.drv INTEGER hPrinter

	lcPrinter = SET("Printer", 3)
	IF NOT EMPTY(lcPrinter)
		lhWindow = GetActiveWindow()

		lhPrinter = 0
		OpenPrinter(lcPrinter, @lhPrinter, 0)
		IF lhPrinter = 0
			Messagebox("Could not open printer.", 48, "Error")
			RETURN
		ENDIF

		lcRptFile = SYS(2015)+".FRX"

		TRY
			* Use a unique file name so we can use this in a multi-user situation
			* Using a cursor instead of a physical file doesn't work, but we can
			* create the FRX from a cursor.
			CREATE CURSOR TempCur (Temp C (10))
			CREATE REPORT (JUSTSTEM(lcRptFile)) FROM TempCur
			USE IN TempCur
			USE (lcRptFile) EXCLUSIVE ALIAS RptFile

			* Use SYS(1037,2) to read the printer settings instead of DocumentProperties
			SYS(1037,2)

			* We only want to save the original settings the first time
			lcOldExpr = EXPR
			lcOldTag  = TAG
			lcOldTag2 = TAG2
			lcOrigDevMode     = TAG2
			lcDevMode = TAG2
			lcModifiedDevMode = TAG2

			* Show printer settings dialog.
			lnResult = DocumentProperties(lhWindow, lhPrinter, lcPrinter, @lcModifiedDevMode, @lcOrigDevMode, DM_IN_PROMPT+DM_IN_BUFFER+DM_OUT_BUFFER)

			IF lnResult <> IDCANCEL
			* Set the printer to the new options
				SELECT RptFile
				replace expr WITH '', ;
					tag WITH '', ;
					TAG2 WITH lcModifiedDevMode
				lcDevMode = lcModifiedDevMode
				SYS(1037,3)		&& Writes the printer settings out to the printer
			ENDIF
		CATCH TO loException
		FINALLY 
			* Get rid of the temporary FRX
			IF USED("RptFile")
				USE IN RptFile
			ENDIF 
			IF FILE(lcRptFile)
				ERASE (JUSTSTEM(lcRptFile)+".*")
			ENDIF 

			* Close the printer handle
			IF NOT EMPTY(lhPrinter)
				ClosePrinter(lhPrinter)
			ENDIF 
		ENDTRY 
	ENDIF

ENDPROC 